<script lang="ts">
  import "@material-design-icons/font/round.css";

  import Icon from "./Icon.svelte";

  export let variant: "default" | "outline" | "text" = "default";
  export let disableShadow: boolean = false;
  export let disabled: boolean = false;
  export let startIcon: string | null = null;
  export let endIcon: string | null = null;
  export let altIcon: string = "";
  export let size: "sm" | "md" | "lg" = "md";
  export let color: "default" | "primary" | "secondary" | "danger" = "default";
</script>

<button
  class="btn"
  class:btn--outline={variant === "outline"}
  class:btn--text={variant === "text"}
  class:no-shadow={disableShadow}
  class:disabled
  class:sm={size === "sm"}
  class:lg={size === "lg"}
  class:primary={color === "primary"}
  class:secondary={color === "secondary"}
  class:danger={color === "danger"}
  {disabled}
  on:click
  on:focus
  on:blur
  on:focusout
  on:submit
  on:focusin
  on:dblclick
  on:auxclick
  on:keydown
  on:keypress
  on:keyup
  on:mousedown
  on:mouseenter
  on:mouseleave
  on:mousemove
  on:mouseout
  on:mouseover
  on:mouseup
  on:touchcancel
  on:touchend
  on:touchmove
  on:touchstart
>
  {#if startIcon}
    <Icon src={startIcon} alt={altIcon} />
  {/if}
  <slot>Default</slot>
  {#if endIcon}
    <Icon src={endIcon} alt={altIcon} />
  {/if}
</button>

<style lang="scss">
  @mixin on-activity {
    &:hover,
    &:focus,
    &:active {
      &:not(.disabled) {
        @content;
      }
    }
  }

  .btn {
    border: none;
    font: inherit;
    color: var(--color-default--fg, #3f3f3f);
    background-color: var(--color-default--bg, #e0e0e0);
    padding: var(--btn-padding--md, 0.8rem 1.6rem);
    border-radius: 0.6rem;
    box-shadow: 0 0.2rem 0.3rem
      var(--color-primary--shadow, rgb(51 51 51 / 20%));
    cursor: pointer;
    display: flex;
    align-items: center;
    justify-content: center;
    gap: 0.8rem;
    transition: background-color 150ms ease-in-out;

    @include on-activity {
      background-color: var(--color-default--bg--activity, #aeaeae);
    }

    &--outline {
      outline: 1px solid currentcolor;
    }

    &--outline,
    &--text {
      background-color: transparent;
      box-shadow: none;

      @include on-activity {
        background-color: var(
          --color-default-empty--bg--activity,
          rgb(51 51 51 / 10%)
        );
      }

      &.primary,
      &.secondary,
      &.danger {
        background-color: transparent;
        box-shadow: none;
      }

      &.primary {
        color: var(--color-primary--bg, #2962ff);

        @include on-activity {
          background-color: var(
            --color-primary-empty--bg--activity,
            rgb(41 98 255 / 10%)
          );
        }
      }

      &.secondary {
        color: var(--color-secondary--bg, #455a64);

        @include on-activity {
          background-color: var(
            --color-secondary-empty--bg--activity,
            rgb(69 90 100 / 10%)
          );
        }
      }

      &.danger {
        color: var(--color-danger--bg, #d32f2f);

        @include on-activity {
          background-color: var(
            --color-danger-empty--bg--activity,
            rgb(211 47 47 / 10%)
          );
        }
      }
    }
  }

  .no-shadow {
    box-shadow: none;

    &.primary,
    &.secondary,
    &.danger {
      box-shadow: none;
    }
  }

  .disabled {
    cursor: not-allowed;
    color: var(--color-default-disabled--fg, #9e9e9e);
    box-shadow: none;

    &.primary {
      color: var(--color-primary-disabled--fg, #6b92fe);
      box-shadow: none;
    }

    &.secondary {
      color: var(--color-secondary-disabled--fg, #707f86);
      box-shadow: none;
    }

    &.danger {
      color: var(--color-danger-disabled--fg, #f97a7a);
      box-shadow: none;
    }
  }

  .sm {
    padding: var(--btn-padding--sm, 0.6rem 1.2rem);
  }

  .lg {
    padding: var(--btn-padding--lg, 1.1rem 2.2rem);
  }

  .primary {
    background-color: var(--color-primary--bg, #2962ff);
    color: var(--color-primary--fg, #fff);
    box-shadow: 0 0.2rem 0.3rem
      var(--color-primary--shadow, rgb(41 98 255 / 20%));

    @include on-activity {
      background-color: var(--color-primary--bg--activity, #0039cb);
    }
  }

  .secondary {
    background-color: var(--color-secondary--bg, #455a64);
    color: var(--color-secondary--fg, #fff);
    box-shadow: 0 0.2rem 0.3rem
      var(--color-secondary--shadow, rgb(69 90 100 / 20%));

    @include on-activity {
      background-color: var(--color-secondary--bg--activity, #1c313a);
    }
  }

  .danger {
    background-color: var(--color-danger--bg, #d32f2f);
    color: var(--color-danger--fg, #fff);
    box-shadow: 0 0.2rem 0.3rem
      var(--color-danger--shadow, rgb(211 47 47 / 20%));

    @include on-activity {
      background-color: var(--color-danger--bg--activity, #9a0007);
    }
  }
</style>
